## plasma-widget-menubar 0.1.13

=== CMakeLists.txt ===
project(plasma-widget-menubar)

cmake_minimum_required(VERSION 2.6)
set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_SOURCE_DIR}/cmake/modules")

# Find the required libraries
find_package(KDE4 4.4 REQUIRED)
include(KDE4Defaults)
find_package(PkgConfig REQUIRED)
pkg_check_modules(DBUSMENUQT REQUIRED dbusmenu-qt>=0.6.0)

find_package(QJson REQUIRED)

include_directories(
    ${KDE4_INCLUDES}
    ${DBUSMENUQT_INCLUDE_DIRS}
    ${QJSON_INCLUDE_DIR}
    )

link_directories(
    ${DBUSMENUQT_LIBRARY_DIRS}
    )

add_subdirectory(src)
add_subdirectory(tests)

# Packaging
set(PROJECT_VERSION "0.1.13")
set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${PROJECT_VERSION})
add_custom_target(dist
    COMMAND bzr export --root=${ARCHIVE_NAME} ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2
    WORKING_DIRECTORY ${CMAKE_SOURCE_DIR})

add_custom_target(distcheck
    COMMAND cd ${CMAKE_BINARY_DIR}
    && rm -rf ${ARCHIVE_NAME}
    && tar xf ${ARCHIVE_NAME}.tar.bz2
    && mkdir ${ARCHIVE_NAME}/build
    && cd ${ARCHIVE_NAME}/build
    && cmake -DCMAKE_INSTALL_PREFIX=../install ..
    && make
    && make install
    && make check
    )
add_dependencies(distcheck dist)

=== src/CMakeLists.txt ===
include_directories(
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
    )

set(menubar_SRCS
    gtkicontable.cpp
    menubarapplet.cpp
    menucloner.cpp
    menuutils.cpp
    menuwidget.cpp
    registrar.cpp
    windowmenumanager.cpp
    )

qt4_add_dbus_adaptor(menubar_SRCS org.ayatana.AppMenu.Registrar.xml
    registrar.h Registrar)

qt4_add_dbus_adaptor(menubar_SRCS org.ayatana.AppMenu.Renderer.xml
    menubarapplet.h MenuBarApplet)

kde4_add_plugin(plasma_applet_menubar ${menubar_SRCS})

target_link_libraries(plasma_applet_menubar
    ${KDE4_PLASMA_LIBS}
    ${KDE4_KIO_LIBS}
    ${DBUSMENUQT_LIBRARIES}
    ${QJSON_LIBRARY}
    )

install(TARGETS plasma_applet_menubar
    DESTINATION ${PLUGIN_INSTALL_DIR})

install(FILES
    plasma-applet-menubar.desktop
    DESTINATION ${SERVICES_INSTALL_DIR})

=== debian/changelog ===
plasma-widget-menubar (0.1.13-0ubuntu1) maverick; urgency=low

  * New upstream release
  * Remove kubuntu_01_fix_translation_template.diff, now upstream

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 09 Sep 2010 16:18:02 +0100

plasma-widget-menubar (0.1.12-0ubuntu2) maverick; urgency=low

  * Add kubuntu_01_fix_translation_template.diff to create correct
    translation template, LP: #633446

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 08 Sep 2010 20:07:36 +0100

plasma-widget-menubar (0.1.12-0ubuntu1) maverick; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 03 Sep 2010 17:21:24 +0100

plasma-widget-menubar (0.1.11-0ubuntu1) maverick; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 19 Aug 2010 15:08:21 +0100

plasma-widget-menubar (0.1.10-0ubuntu1) maverick; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 05 Aug 2010 16:12:24 +0100

plasma-widget-menubar (0.1.9-0ubuntu2) maverick; urgency=low

  * Add build-dep on libqjson-dev

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 23 Jul 2010 10:05:37 +0100

plasma-widget-menubar (0.1.9-0ubuntu1) maverick; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 23 Jul 2010 09:25:36 +0100

plasma-widget-menubar (0.1.8-0ubuntu1) maverick; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 08 Jul 2010 21:10:52 +0100

plasma-widget-menubar (0.1.7-0ubuntu1) maverick; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Mon, 28 Jun 2010 17:00:01 +0100

plasma-widget-menubar (0.1.6-0ubuntu1) maverick; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Fri, 25 Jun 2010 14:27:25 +0100

plasma-widget-menubar (0.1.5-0ubuntu1) maverick; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 17 Jun 2010 14:37:07 +0100

plasma-widget-menubar (0.1.3-0ubuntu1) maverick; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 10 Jun 2010 23:52:56 +0100

plasma-widget-menubar (0.1.2-0ubuntu1) maverick; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 02 Jun 2010 17:25:21 +0100

plasma-widget-menubar (0.1.1-0ubuntu1) maverick; urgency=low

  * Initial release

 -- Aurélien Gâteau <aurelien.gateau@canonical.com>  Wed, 19 May 2010 17:56:38 +0200

=== debian/control ===
Source: plasma-widget-menubar
Section: kde
Priority: extra
Maintainer: Ubuntu MOTU Developers <ubuntu-motu@lists.ubuntu.com>
XSBC-Original-Maintainer: Aurélien Gâteau <aurelien.gateau@canonical.com>
Build-Depends: cdbs, debhelper (>= 7), cmake, kdelibs5-dev, libdbusmenu-qt-dev (>= 0.6.0), pkg-config, libqjson-dev
Standards-Version: 3.8.4
Homepage: https://launchpad.net/plasma-widget-menubar
#Vcs-Bzr: lp:~kubuntu-members/plasma-widget-menubar/ubuntu
#Vcs-Browser: http://bazaar.launchpad.net/~kubuntu-members/plasma-widget-menubar/ubuntu/changes

Package: plasma-widget-menubar
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: A Plasma applet to display application menubars
 A Plasma applet to displays application menubars.

## plasma-widget-menubar 0.1.15

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 add_subdirectory(tests)
 
 # Packaging
-set(PROJECT_VERSION "0.1.13")
+set(PROJECT_VERSION "0.1.15")
 set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${PROJECT_VERSION})
 add_custom_target(dist
     COMMAND bzr export --root=${ARCHIVE_NAME} ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2

=== debian/changelog ===
plasma-widget-menubar (0.1.15-0ubuntu1) natty; urgency=low

  * New upstream release

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 24 Mar 2011 14:00:43 +0000

plasma-widget-menubar (0.1.14-0ubuntu1) natty; urgency=low

  * New upstream release
    - Add kubuntu_01_disable_tests.diff to disable failing tests
  * Switch from kde.mk to the debhelper short rules with the kde addon:
    - Bump pkg-kde-tools build-depend version to 0.5.0 or higher
  * Bump debhelper/compat version to 8
  * Bump Standards-Version to 3.9.1

 -- Jonathan Thomas <echidnaman@kubuntu.org>  Mon, 17 Jan 2011 12:01:35 -0500

plasma-widget-menubar (0.1.13-0ubuntu4) natty; urgency=low

  * Add dependency on appmenu-qt

 -- Jonathan Riddell <jriddell@ubuntu.com>  Wed, 12 Jan 2011 21:53:17 +0000

plasma-widget-menubar (0.1.13-0ubuntu3) natty; urgency=low

  * Actually add the missing build-dep on pkg-kde-tools

 -- Scott Kitterman <scott@kitterman.com>  Thu, 23 Dec 2010 01:08:45 -0500

plasma-widget-menubar (0.1.13-0ubuntu2) natty; urgency=low

  * Add missing build-depends on pkg-kde-tools

 -- Scott Kitterman <scott@kitterman.com>  Thu, 23 Dec 2010 01:00:11 -0500

=== debian/control ===
Source: plasma-widget-menubar
Section: kde
Priority: extra
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Aurélien Gâteau <aurelien.gateau@canonical.com>
Build-Depends: debhelper (>= 8.0.0~), cmake, kdelibs5-dev, libdbusmenu-qt-dev (>= 0.6.0), pkg-config, libqjson-dev, pkg-kde-tools (>= 0.5.0)
Standards-Version: 3.9.1
Homepage: https://launchpad.net/plasma-widget-menubar
#Vcs-Bzr: lp:~kubuntu-members/plasma-widget-menubar/ubuntu
#Vcs-Browser: http://bazaar.launchpad.net/~kubuntu-members/plasma-widget-menubar/ubuntu/changes

Package: plasma-widget-menubar
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, appmenu-qt
Description: A Plasma applet to display application menubars
 A Plasma applet to displays application menubars.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with kde

#disable until test suite actually passes
#common-post-build-arch::
#	make -C obj-*/tests buildtests
#	make -C obj-*/tests test

## plasma-widget-menubar 0.1.16

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 add_subdirectory(tests)
 
 # Packaging
-set(PROJECT_VERSION "0.1.15")
+set(PROJECT_VERSION "0.1.16")
 set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${PROJECT_VERSION})
 add_custom_target(dist
     COMMAND bzr export --root=${ARCHIVE_NAME} ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2

=== debian/changelog ===
plasma-widget-menubar (0.1.16-0ubuntu1) oneiric; urgency=low

  * New upstream bugfix release
    - Change Vcs-Browser and Vcs-Bzr

 -- Romain Perier <bambi@ubuntu.com>  Mon, 12 Sep 2011 11:45:31 +0200

plasma-widget-menubar (0.1.15-0ubuntu2) oneiric; urgency=low

  * Fix FTBFS by adding missing build-depends on libx11-dev (LP: #829503)

 -- Scott Kitterman <scott@kitterman.com>  Sat, 20 Aug 2011 11:19:03 -0400

=== debian/control ===
Source: plasma-widget-menubar
Section: kde
Priority: extra
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Aurélien Gâteau <aurelien.gateau@canonical.com>
Build-Depends: debhelper (>= 8.0.0~), cmake, kdelibs5-dev, libdbusmenu-qt-dev (>= 0.6.0), pkg-config, libqjson-dev, pkg-kde-tools (>= 0.5.0), libx11-dev
Standards-Version: 3.9.1
Homepage: https://launchpad.net/plasma-widget-menubar
Vcs-Browser: http://bazaar.launchpad.net/~kubuntu-packagers/kubuntu-packaging/plasma-widget-menubar
Vcs-Bzr: lp:~kubuntu-packagers/kubuntu-packaging/plasma-widget-menubar

Package: plasma-widget-menubar
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, appmenu-qt
Description: A Plasma applet to display application menubars
 A Plasma applet to displays application menubars.

## plasma-widget-menubar 0.1.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 add_subdirectory(tests)
 
 # Packaging
-set(PROJECT_VERSION "0.1.16")
+set(PROJECT_VERSION "0.1.17")
 set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${PROJECT_VERSION})
 add_custom_target(dist
     COMMAND bzr export --root=${ARCHIVE_NAME} ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2

=== debian/changelog ===
plasma-widget-menubar (0.1.17-1) unstable; urgency=low

  * New upstream release
  * Upload to unstable
  * [ab2d37b] Imported Upstream version 0.1.17
  * [0349cd4] update standards version to 3.9.3
    - [9239fe8] update copyright to machine readable format 1.0
    - [e69a5f4] add Vcs headers

 -- Ritesh Raj Sarraf <rrs@debian.org>  Thu, 17 May 2012 01:30:31 +0530

plasma-widget-menubar (0.1.16-1) experimental; urgency=low

  * Initial release. (Closes: #666495)

 -- Ritesh Raj Sarraf <rrs@debian.org>  Sat, 31 Mar 2012 13:29:55 +0530

=== debian/control ===
Source: plasma-widget-menubar
Section: kde
Priority: extra
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper (>= 7.0.50~), libqt4-dev (>= 4:4.8), kdelibs-bin, cmake, kdelibs5-dev, kde-workspace-dev, libx11-dev, libxext-dev, pkg-config, libqjson-dev, libdbusmenu-qt-dev
Standards-Version: 3.9.3
Homepage: https://launchpad.net/plasma-widget-menubar
Vcs-Git: git://git.debian.org/pkg-kde/kde-extras/plasma-widget-menubar.git
Vcs-Browser: http://git.debian.org/?p=pkg-kde/kde-extras/plasma-widget-menubar.git

Package: plasma-widget-menubar
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: plasma widget to display menubar of application windows
 plamsa-widget-menubar provides a unified global menubar for all KDE
 and Qt applications
 .
 It is provided as a widget which can be added to the panel

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# export DH_VERBOSE=1
export DH_OPTIONS

%:
	dh $@

override_dh_auto_test:
	# don't run the tests

override_dh_installchangelogs:
	dh_installchangelogs NEWS

## plasma-widget-menubar 0.1.18

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 add_subdirectory(tests)
 
 # Packaging
-set(PROJECT_VERSION "0.1.17")
+set(PROJECT_VERSION "0.1.18")
 set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${PROJECT_VERSION})
 add_custom_target(dist
     COMMAND bzr export --root=${ARCHIVE_NAME} ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -13,10 +13,10 @@
     windowmenumanager.cpp
     )
 
-qt4_add_dbus_adaptor(menubar_SRCS org.ayatana.AppMenu.Registrar.xml
+qt4_add_dbus_adaptor(menubar_SRCS com.canonical.AppMenu.Registrar.xml
     registrar.h Registrar)
 
-qt4_add_dbus_adaptor(menubar_SRCS org.ayatana.AppMenu.Renderer.xml
+qt4_add_dbus_adaptor(menubar_SRCS com.canonical.AppMenu.Renderer.xml
     menubarapplet.h MenuBarApplet)
 
 kde4_add_plugin(plasma_applet_menubar ${menubar_SRCS})

=== tests/CMakeLists.txt ===
include_directories(
    ${CMAKE_SOURCE_DIR}/src
    )

set(test_LIBRARIES
    ${KDE4_PLASMA_LIBS}
    ${KDE4_KIO_LIBS}
    ${QT_QTTEST_LIBRARY}
    ${QJSON_LIBRARY}
    )

# Hackish, but defining dependencies as "DEPENDS buildtests test" does not
# work :(
add_custom_target(check COMMAND ${CMAKE_BUILD_TOOL} buildtests test)

# gtkicontabletest
set(gtkicontabletest_SRCS
    gtkicontabletest.cpp
    ../src/gtkicontable.cpp
    )

kde4_add_unit_test(gtkicontabletest ${gtkicontabletest_SRCS})

target_link_libraries(gtkicontabletest
    ${test_LIBRARIES}
    )

=== debian/changelog ===
plasma-widget-menubar (0.1.18-0ubuntu2) raring; urgency=low

  * Add X-Ubuntu-Use-Langpack: yes

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 28 Mar 2013 17:36:01 +0000

plasma-widget-menubar (0.1.18-0ubuntu1) quantal; urgency=low

  * New upstream release
  * Bump Standards-Version to 3.9.3.1, no changes required

 -- Jonathan Thomas <echidnaman@kubuntu.org>  Mon, 04 Jun 2012 22:10:03 -0400

plasma-widget-menubar (0.1.17-0ubuntu1) precise; urgency=low

  * New upstream release
  * Drop patch to disable tests as test suite does not require X anymore
  * Add build dependency on gnome-icon-theme-full so that gtkicontabletest
    finds the necessary images

 -- Aurélien Gâteau <aurelien.gateau@ubuntu.com>  Wed, 04 Apr 2012 10:13:50 +0200

=== debian/control ===
Source: plasma-widget-menubar
Section: kde
Priority: extra
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Aurélien Gâteau <aurelien.gateau@canonical.com>
X-Ubuntu-Use-Langpack: yes
Build-Depends: debhelper (>= 8.0.0~), cmake, kdelibs5-dev, libdbusmenu-qt-dev (>= 0.6.0), pkg-config, libqjson-dev, pkg-kde-tools (>= 0.5.0), libx11-dev, gnome-icon-theme-full
Standards-Version: 3.9.3.1
Homepage: https://launchpad.net/plasma-widget-menubar
Vcs-Browser: http://bazaar.launchpad.net/~kubuntu-packagers/kubuntu-packaging/plasma-widget-menubar
Vcs-Bzr: lp:~kubuntu-packagers/kubuntu-packaging/plasma-widget-menubar

Package: plasma-widget-menubar
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, appmenu-qt
Description: A Plasma applet to display application menubars
 A Plasma applet to displays application menubars.

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@ --with kde

override_dh_auto_test:
	make -C obj-*/tests check

=== debian/watch ===
version=3
https://launchpad.net/plasma-widget-menubar/+download \
http://launchpad.net/plasma-widget-menubar/trunk/\d.\d.\d/\+download/plasma-widget-menubar-(.*)\.tar\.bz2

## plasma-widget-menubar 0.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -22,10 +22,10 @@
     )
 
 add_subdirectory(src)
-add_subdirectory(tests)
+#add_subdirectory(tests)
 
 # Packaging
-set(PROJECT_VERSION "0.1.18")
+set(PROJECT_VERSION "0.2.0")
 set(ARCHIVE_NAME ${CMAKE_PROJECT_NAME}-${PROJECT_VERSION})
 add_custom_target(dist
     COMMAND bzr export --root=${ARCHIVE_NAME} ${CMAKE_BINARY_DIR}/${ARCHIVE_NAME}.tar.bz2

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -4,17 +4,14 @@
     )
 
 set(menubar_SRCS
-    gtkicontable.cpp
     menubarapplet.cpp
     menucloner.cpp
     menuutils.cpp
     menuwidget.cpp
-    registrar.cpp
+    importer_interface.cpp
+    kappmenuimporter.cpp
     windowmenumanager.cpp
     )
-
-qt4_add_dbus_adaptor(menubar_SRCS com.canonical.AppMenu.Registrar.xml
-    registrar.h Registrar)
 
 qt4_add_dbus_adaptor(menubar_SRCS com.canonical.AppMenu.Renderer.xml
     menubarapplet.h MenuBarApplet)

=== debian/changelog ===
plasma-widget-menubar (0.2.0-2) unstable; urgency=medium

  [ Felix Geyer ]
  * [ce20be6] Switch to debhelper compat level v9 which exports build flags.
  * [b2a8456] Enable parallel building.
  * [e2096e2] Append -Wl,--as-needed to LDFLAGS.
  * [923346c] Remove unnecessary build-depends.
  * [631ae0e] Use the pkg-kde-tools dh helper.

  [ Ritesh Raj Sarraf ]
  * [4695378] Bump Debhelper dependency to 9.0
  * [a66590a] Add pkg-kde-tools build dependency

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 15 Oct 2014 14:07:39 +0530

plasma-widget-menubar (0.2.0-1) unstable; urgency=medium

  * [88906e3] Imported Upstream version 0.2.0
  * [576d447] fix lintian warning for machine readable (1.0) format
  * [b1c6b3a] fix license field order
  * [798a224] Add Recommends on appmenu-qt
  * [cffcf70] Update Vcs links
  * [c39d075] Enable hardening build

 -- Ritesh Raj Sarraf <rrs@debian.org>  Wed, 15 Oct 2014 13:28:25 +0530

=== debian/control ===
Source: plasma-widget-menubar
Section: kde
Priority: extra
Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Ritesh Raj Sarraf <rrs@debian.org>
Build-Depends: debhelper (>= 9), libqt4-dev (>= 4:4.8), kdelibs-bin, cmake, kdelibs5-dev, kde-workspace-dev, libx11-dev, libxext-dev, pkg-config, libqjson-dev, libdbusmenu-qt-dev, dpkg-dev (>= 1.16.1~), pkg-kde-tools
Standards-Version: 3.9.3
Homepage: https://launchpad.net/plasma-widget-menubar
Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-extras/plasma-widget-menubar.git
Vcs-Browser: https://anonscm.debian.org/cgit/pkg-kde/kde-extras/plasma-widget-menubar.git

Package: plasma-widget-menubar
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: appmenu-qt
Description: plasma widget to display menubar of application windows
 plamsa-widget-menubar provides a unified global menubar for all KDE
 and Qt applications
 .
 It is provided as a widget which can be added to the panel

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# For Hardening
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk


export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

%:
	dh $@ --parallel --with kde

override_dh_auto_test:
	# don't run the tests

override_dh_installchangelogs:
	dh_installchangelogs NEWS

=== debian/watch ===
# upstream seems to ship with kde-apps.
# TODO: Need to figure out a way to track it
